#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <sys/wait.h>
#include <signal.h>

#include <errno.h>

#include "zlib.h"

#ifndef INPORT
#define	INPORT	32100
#endif

void sig_child(int sig)
{
	signal(SIGCHLD,sig_child);
	while(waitpid(-1,NULL,WNOHANG) > 0);
}

int main(int argc, char **argv)
{
	struct	sockaddr_in sai;
	char	tmp[800];
	char	inet_xor[10];
	int	inet_xor_ct;
	int	s,ss,i,l;
	gzFile	gzo;

	if (fork())
		exit(0);
	sleep(1);
	setsid();

	signal(SIGCHLD,sig_child);

#ifndef NOHELP
	fprintf(stderr,"@(#)reapdump.c 2.1 Copyright (C) 1997-2000 UNiC\n");
#endif
	if ((s = socket(AF_INET,SOCK_STREAM,6)) < 0)
		exit(1);
	sai.sin_family = AF_INET;
	sai.sin_addr.s_addr = INADDR_ANY;
	sai.sin_port = htons(INPORT);
	if (bind(s,(struct sockaddr*)&sai,sizeof(sai)) < 0)
		exit(1);
	if (listen(s,2) < 0)
		exit(1);
	while(1)
	{
		l = sizeof(sai);
		if ((ss = accept(s,(struct sockaddr*)&sai,&l)) < 0)
		{
			if (errno == EINTR)
				continue;
			exit(1);
		}
		if (fork() == 0)
		{
			l = getpid();
			sprintf(tmp,".g%i",l);
			gzo = gzopen(tmp,"wb6");
			i = 10;
			while(i)
			{
				l = read(ss,&inet_xor[10-i],10);
				i -= l;
			}
			inet_xor_ct = 0;
			while(1)
			{
				l = read(ss,tmp,sizeof(tmp));
				if (l <= 0)
				{
					gzclose(gzo);
					exit(-l);
				}
				i = 0;
				while(i < l)
				{
					tmp[i] = tmp[i] ^ inet_xor[inet_xor_ct];
					inet_xor_ct++;
					if (inet_xor_ct >= 10)
						inet_xor_ct = 0;
					i++;
				}
				gzwrite(gzo,tmp,l);
			}
		}
		close(ss);
	}
	return(0);
}
